Kad Onion
=========

[![Build Status](https://img.shields.io/travis/kadtools/kad-onion/master.svg?style=flat-square)](https://travis-ci.org/kadtools/kad-onion) 
[![Coverage Status](https://img.shields.io/coveralls/kadtools/kad-onion.svg?style=flat-square)](https://coveralls.io/r/kadtools/kad-onion) 
[![NPM](https://img.shields.io/npm/v/kad-onion.svg?style=flat-square)](https://www.npmjs.com/package/kad-onion)

[Tor](https://torproject.org) plugin for 
[Kad](https://github.com/kadtools/kad)! Automatically run your DHT node as a 
hidden service and communicate with peers over the Tor network.

Usage
-----

```
npm install kad-onion --save
```

If you want to use Version 2 hidden services, see the documentation for 
[`kad-onion@1.8.0`](https://github.com/kadtools/kad-onion/blob/v1.8.0/README.md).

```
npm install kad-onion@1.8.0 --save
```

```js
const kad = require('kad');
const onion = require('kad-onion');

const node = kad({
  // ...
  transport: new kad.HTTPTransport()
});

node.plugin(onion({
  dataDirectory: '/tmp/kad-onion', // Set to persist onion hostname
  virtualPort: 80,
  localMapping: '127.0.0.1:8080'
}));

node.listen(8080, function() {
  console.log(node.contact); // { hostname: 'kadl4viaeoutiv2e.onion', port: 80 }
});
```

License
-------

Kad Onion - SOCKS5 proxy support for Kad, preconfigured for using Tor  
Copyright (C) 2017 Gordon Hall

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.


